<?php

class DispletRetsIdxApi extends DispletRetsIdxPlugin{
	public function query($endpoint_url, $args, $method = false){
		global $displetretsidx_option;
		$home_url = home_url();
		$query_args = array(
			'timeout' => 10,
			'headers' => array(
				'referer' => $home_url
			)
		);
		if (!empty($displetretsidx_option['displet_app_key'])) {
			$query_url = parent::$api_url . $endpoint_url;
			$query_string_args = array(
				'authentication_token' => $displetretsidx_option['displet_app_key']
			);
		}
		else{
			$query_url = 'http://api.oodle.com/api/v2/listings';
			$query_string_args = array(
				'key' => self::get_free_key(),
				'format' => 'json',
				'jsoncallback' => 'none',
				'num_images' => '1',
				'image_sizes' => 'm'
			);
		}
		if (!empty($args) && is_array($args)) {
			foreach ($args as $key => $value) {
				if ($value != 'property_filter_excluded') {
					$query_string_args[$key] = $value;
				}
			}
		}
		$single_dimensional_args = array();
		foreach ($query_string_args as $key => $value) {
			$single_dimensional_args[] = $key . '=' . urlencode($value);
		}
		$query_url .= '?' . implode('&', $single_dimensional_args);
		if (!empty($method) && $method != 'GET') {
			$query_args['method'] = $method;
		}
		if (!empty($method) && $method == 'GET'){
			$json_array = wp_remote_get($query_url, $query_args);
		}
		else{
			$json_array = wp_remote_post($query_url, $query_args);
		}
		if (is_array($json_array) && !empty($json_array['body'])) {
			$results = json_decode($json_array['body']);
			if (is_object($results)) {
				$results->query_url = $query_url;
			}
			return $results;
		}
		return false;
	}

	private function get_free_key(){
		$remainder = time() % 3;
		if ($remainder === 0) {
			return '0F35256B0FAC';
		}
		else if ($remainder === 1) {
			return 'B9A2E1A6AB5F';
		}
		return '579B95506556';
	}
}

require_once('api/displet-property-suggestions-api.php');
require_once('api/displet-residentials-api.php');
require_once('api/displet-users-api.php');

?>