<?php

class DispletRetsIdxUtilities{
	/*****************************
	/ String manipulation
	*****************************/

	public function remove_url_prefixes($string){
		return str_replace(array('http://www.', 'https://www.', 'http://', 'https://'), '', $string);
	}

	public function remove_url_suffixes($string){
		if (strpos($string, '/') !== false) {
			return substr($string, 0, strpos($string, '/'));
		}
		return $string;
	}

	public function get_domainless_url($string){
		$unprefixed = self::remove_url_prefixes($string);
		if (strpos($unprefixed, '/') !== false) {
			return substr($unprefixed, strpos($unprefixed, '/'), strlen($unprefixed) - 1);
		}
		return $unprefixed;
	}

	public function add_spaces_after_commas($string){
		$string = preg_replace('/(,$)/', '', $string);
		return preg_replace('/(?<=,)(?!\\s)/', ' ', $string);
	}

	public function get_address_from_property_details_suffix($string){
		if (!empty($string)) {
			preg_match('~([^/]+)/?([^/]*)/?([^/]*)/?([^/]*)/?([^/]*)/?~', $string, $matches);
			if (!empty($matches[5])) {
				return str_replace('-', ' ', $matches[5]);
			}
		}
		return false;
	}
	
	/*****************************
	/ Option related
	*****************************/

	public function is_new_api_key($original_option, $new_option){
		return self::is_option_new('displet_app_key', $original_option, $new_option);
	}

	public function is_new_api_token($original_option, $new_option){
		return self::is_option_new('displet_app_token', $original_option, $new_option);
	}

	public function is_new_email_address($original_option, $new_option){
		return self::is_option_new('email_from_address', $original_option, $new_option);
	}

	public function email_activity_has_changed($original_option, $new_option){
		return self::has_option_changed('email_activity', $original_option, $new_option);
	}

	public function is_option_new($array_key, $original_option, $new_option){
		if (!empty($new_option[$array_key]) && self::has_option_changed($array_key, $original_option, $new_option)) {
			return true;
		}
		return false;
	}

	public function has_option_changed($array_key, $original_option, $new_option){
		if (empty($original_option[$array_key]) || $new_option[$array_key] !== $original_option[$array_key]) {
			return true;
		}
		return false;
	}

	public function get_widget_area($slug, $name){
		if (!function_exists('dynamic_sidebar') || !dynamic_sidebar($slug)) {
			if (current_user_can('manage_options')) {
				echo 'Insert Displet Search Field widgets into the ' . $name . ' widget area on your <a href="' . admin_url('widgets.php') . '">Widgets page</a>.';
			}
		}
	}
	
	/*****************************
	/ Miscellaneous
	*****************************/

	public function is_referral_function($f) {
		$aray = debug_backtrace(DEBUG_BACKTRACE_IGNORE_ARGS);
		foreach($aray as $a) {	$aa[] = $a["function"];	}
		if(in_array($f,$aa)) { return true; }
		return false;
	}
}

?>